%%Author: Pallavi A Raiturkar
%%
%script to plot boxplot of only correct average saccade length
%%
clear all;
clc;
studyName = 'irb';
load('avgSaccadeLength');
load('fixationNumber');
load('dwellTime_avg');
filename_read = ['..\..\intermediate\' studyName '\eyetrackingcg_data.xlsx']; %Replace with filepath containing data table
[~,~,data]=xlsread(filename_read);

avgSaccadeLength_cg = avgSaccadeLength(1:30,:);
avgSaccadeLength_photo = avgSaccadeLength(30:end,:);
fixationNumber_cg = fixationNumber(1:30,:);
fixationNumber_photo = fixationNumber(31:end,:);
dwellTime_avg_cg = dwellTime_avg(1:31,:);
dwellTime_avg_photo = dwellTime_avg(31:end,:);

correctness = data(2:end,9);

correctness = reshape(correctness,[60 35]);
correctness(:,35) = [];
correctness(:,16) = [];

correctness_cg = correctness(1:30,:);
correctness_photo = correctness(31:60,:);

correctness_cg = reshape(strcmp(correctness_cg,'correct'),[30,33]);
correctness_photo = reshape(strcmp(correctness_photo,'correct'),[30,33]);

avgSaccadeLength_cg_correct = avgSaccadeLength_cg(correctness_cg==1);
avgSaccadeLength_photo_correct = avgSaccadeLength_photo(correctness_photo==1);

avgSaccadeLength_cg_incorrect = avgSaccadeLength_cg(correctness_cg==0);
avgSaccadeLength_photo_incorrect = avgSaccadeLength_photo(correctness_photo==0);

fixationNumber_cg_correct = fixationNumber_cg(correctness_cg==1);
fixationNumber_photo_correct = fixationNumber_photo(correctness_photo==1);

fixationNumber_cg_incorrect = fixationNumber_cg(correctness_cg==0);
fixationNumber_photo_incorrect = fixationNumber_photo(correctness_photo==0);

dwellTime_avg_cg_correct = dwellTime_avg_cg(correctness_cg==1);
dwellTime_avg_photo_correct = dwellTime_avg_photo(correctness_photo==1);

dwellTime_avg_cg_incorrect = dwellTime_avg_cg(correctness_cg==0);
dwellTime_avg_photo_incorrect = dwellTime_avg_photo(correctness_photo==0);

numCorrect = size(avgSaccadeLength_cg_correct,1)+size(avgSaccadeLength_photo_correct,1);
numIncorrect = size(avgSaccadeLength_cg_incorrect,1)+size(avgSaccadeLength_photo_incorrect,1);

%boxplots: avgSaccadeLength
%plot boxplot for correct responses only

avgSaccadeLength_correct = [avgSaccadeLength_cg_correct;avgSaccadeLength_photo_correct];
baseCorrect = [zeros(size(avgSaccadeLength_cg_correct,1),1);ones(size(avgSaccadeLength_photo_correct,1),1)];
figure(1);
boxplot(avgSaccadeLength_correct,baseCorrect,'symbol','');
%plot boxplot for incorrect responses only

avgSaccadeLength_incorrect = [avgSaccadeLength_cg_incorrect;avgSaccadeLength_photo_incorrect];
baseIncorrect = [zeros(size(avgSaccadeLength_cg_incorrect,1),1);ones(size(avgSaccadeLength_photo_incorrect,1),1)];
figure(2);
boxplot(avgSaccadeLength_incorrect,baseIncorrect,'symbol','');


%boxplots: fixationNumber
%plot boxplot for correct responses only

fixationNumber_correct = [fixationNumber_cg_correct;fixationNumber_photo_correct];
baseCorrect = [zeros(size(fixationNumber_cg_correct,1),1);ones(size(fixationNumber_photo_correct,1),1)];
figure(3);
boxplot(fixationNumber_correct,baseCorrect,'symbol','');
%plot boxplot for incorrect responses only

fixationNumber_incorrect = [fixationNumber_cg_incorrect;fixationNumber_photo_incorrect];
baseIncorrect = [zeros(size(fixationNumber_cg_incorrect,1),1);ones(size(fixationNumber_photo_incorrect,1),1)];
figure(4);
boxplot(fixationNumber_incorrect,baseIncorrect,'symbol','');


%boxplots: dwellTime_avg
%plot boxplot for correct responses only

dwellTime_avg_correct = [dwellTime_avg_cg_correct;dwellTime_avg_photo_correct];
baseCorrect = [zeros(size(dwellTime_avg_cg_correct,1),1);ones(size(dwellTime_avg_photo_correct,1),1)];
figure(5);
boxplot(dwellTime_avg_correct*1.0e-6,baseCorrect,'symbol','');
%plot boxplot for incorrect responses only

dwellTime_avg_incorrect = [dwellTime_avg_cg_incorrect;dwellTime_avg_photo_incorrect];
baseIncorrect = [zeros(size(dwellTime_avg_cg_incorrect,1),1);ones(size(dwellTime_avg_photo_incorrect,1),1)];
figure(6);
boxplot(dwellTime_avg_incorrect*1.0e-6,baseIncorrect,'symbol','');