%%Author:Pallavi A Raiturkar
%%
%script to compute average intensity in AOI BothEyes across CG and photo
%images
%%
clear all;
clc;
studyName = 'irb';
imgNameList  = returnImageNameList_testing();
% figure;
for i = 7
    imageName = strtok(char(imgNameList(i,:)),'.');
    I = imread(['..\..\stimuli\testing_edited\' imageName '.png']); %read in original image
    aoi = returnImageAOI_botheyes(imageName);
    x1 = aoi.x1;
    x2 = aoi.x2;
    y1 = aoi.y1;
    y2 = aoi.y2;
    x3 = aoi.x1;
    x4 = aoi.x2;
    y3 = aoi.y2;
    y4 = aoi.y1;
%     figure(1);
%     imshow(I),hold on,plot([x1 x2 x3 x4],[y1 y2 y3 y4],'rx')
    if(aoi.angle~=0)
        %compute angle in radians
        angle_rad = aoi.angle*(pi/180);
        %rotate x1,y1 and x2,y2 by angle about center of mass of AOI
        %compute center of mass
        xc =  (x1 + x2)/2;
        yc =  (y1 + y2)/2;
        
        %translate points to center of mass
        x1t = x1 - xc;
        y1t = y1 - yc;
        x2t = x2 - xc;
        y2t = y2 - yc;
        x3t = x3 - xc;
        y3t = y3 - yc;
        x4t = x4 - xc;
        y4t = y4 - yc;
        %rotate around the origin by the angle
        c = cos(angle_rad); 
        s = sin(angle_rad);
        x1r = x1t * c - y1t * s;
        y1r = x1t * s + y1t * c;
        x2r = x2t * c - y2t * s;
        y2r = x2t * s + y2t * c;
        x3r = x3t * c - y3t * s;
        y3r = x3t * s + y3t * c;
        x4r = x4t * c - y4t * s;
        y4r = x4t * s + y4t * c;
        %translate points back:
        
        x1 = x1r + xc;
        y1 = y1r + yc;
        x2 = x2r + xc;
        y2 = y2r + yc;
        x3 = x3r + xc;
        y3 = y3r + yc;
        x4 = x4r + xc;
        y4 = y4r + yc;
    end
    figure;
    imshow(I),hold on,plot([x1 x2 x3 x4],[y1 y2 y3 y4],'bx')
    %%crop AOI_botheyes as image
    [m,n] = size(I(:,:,1)) ;
    %% Four corners 
    data = [
      x1 y1
      x3 y3
      x2 y2
      x4 y4
    ];
    x = data(:,1) ; y = data(:,2) ;
    bI = poly2mask(x,y,m,n);
    figure;
    imshow(bI)
    meas = regionprops(bI, 'BoundingBox');
    croppedImage = imcrop(I, meas.BoundingBox);
    figure;
    imshow(croppedImage);
    imwrite(croppedImage,['../../intermediate/' studyName '/aoi_botheyes/' imageName '.png']);
end