%%Author: Pallavi A Raiturkar
%%
%script to generate average heat maps across n participants
%%
clear all;
clc;
% startTime = 0;
% endTime = 6;
studyName = 'irb2';
participantID_list = returnParticipantList2();

imgNameList  = returnImageNameList_testing();

% participantID_list(35,:) = [];
% participantID_list(16,:) = [];
numParticipants = size(participantID_list,1);
fixationNumber = zeros(60,numParticipants);
dwellTime_avg = zeros(60,numParticipants);
for i = 1:60
pictureName = strtok(char(imgNameList(i)),'.');

%read in stimulus image

%     I = imread(['..\..\stimuli\testing_edited\' pictureName '.png']);

%reduce contrast so that we can see lighter heat map areas
% edgeThreshold = 0;
% amount = -0.6;
% I_lowcontrast = localcontrast(I,edgeThreshold,amount);
% figure('visible','off');
% % % % subplot(1,2,2);
% imshow(I_lowcontrast);
% hold on;

% fixationMap = zeros(1050,1680);
% dwellMap = zeros(1050,1680);

for j = 1:numParticipants
    participantID = participantID_list(j,:);
    folderpath = ['..\..\data\' studyName '\' participantID '\'];
    filepath = [folderpath pictureName '.txt'];
    
    %read and clean eye tracking data
    [eyeTrackingData] = readEyeTrackingData(filepath);
    [eyeTrackingData] = cleanEyeTrackingData(eyeTrackingData);

    %detect fixation and saccades from raw eye tracking data
    [eyeTrackingDistance,eyeTrackingVelocity,eyeTrackingDataLabel,fixation,~,fixationPoints,~] = returnFixationSaccade(eyeTrackingData);
%     fixation = selectPartFixation(fixation,startTime,endTime);
%     [fixationMap] = generateFixationMap(fixationMap,fixation);
%     [dwellMap] = generateDwellMap(dwellMap,fixation);
    fixationNumber(i,j) = size(fixation.index,1);
    dwellTime_avg(i,j) = mean(fixation.duration);
    clear eyeTrackingData 
end

% fixationMap = fixationMap./numParticipants;
% dwellMap = dwellMap./numParticipants;

% sigma = 37; %standard deviation of gaussian filter
% kernelsize  = 201;
% heatMap = imgaussfilt(dwellMap,sigma,'FilterSize',kernelsize); %TOGGLE BETWEEN DWELL OR COUNT (FIXATION)

% 
% heatMapMask = (heatMap/max(max(heatMap))) *1;
% 
% hm=imagesc(heatMap), colormap('jet');
% hm.AlphaData = heatMapMask;
% 
% % saveas(gcf,['../../results/heatmap_count_matlab/' studyName '/allparticipants/' pictureName '.png']);
% saveas(gcf,['../../results/heatmap_dwell_matlab/' studyName '/allparticipants/' pictureName '.png']);

end

save('fixationNumber2');
save('dwellTime_avg2');