%%Author: Pallavi A Raiturkar
%%
%compute fixation maps of image sizes and save
clear all;
clc;
studyName = 'irb';
[imgNameList]  = returnImageNameList_testing();

participantID_list = returnParticipantList();
participantID_list(35,:) = [];
participantID_list(16,:) = [];

numParticipants = size(participantID_list,1);
for i = 1:60
    
    pictureName = strtok(char(imgNameList(i)),'.');
    I = imread(['..\..\stimuli\testing\' pictureName '.png']);
    [sizeIy,sizeIx,~] = size(I);
    xOr = 840 - sizeIx/2;
    yOr = 525 - sizeIy/2;

    for j = 1:numParticipants
        fixationMap = zeros(1050,1680);
        dwellMap = zeros(1050,1680);
        participantID = participantID_list(j,:);
        [fixation] = returnFixation(studyName,pictureName,participantID);
        [fixationMap] = generateFixationMap(fixationMap,fixation);
        [dwellMap] = generateDwellMap(dwellMap,fixation);
        fixationMap = fixationMap(yOr:yOr+sizeIy-1,xOr:xOr+sizeIx-1);
        dwellMap = dwellMap(yOr:yOr+sizeIy-1,xOr:xOr+sizeIx-1);
        save(['..\..\intermediate\irb\fixation_maps_byparticipant\' pictureName '_' participantID '_fixation'],'fixationMap');
        save(['..\..\intermediate\irb\fixation_maps_byparticipant\' pictureName '_' participantID '_dwell'],'dwellMap');
    end

    
end