%%Author: Pallavi A Raiturkar
%%
%script to generate heat map on images
%%
clear all;
clc;

studyName = 'irb2';
[participantID_list] = returnParticipantList();

for j = 20:20
participantID = participantID_list(j,:);
% pictureName = 'photo_f_7';
imgNameList  = returnImageNameList();

for i = 1:80
pictureName = strtok(char(imgNameList(i)),'.');
folderpath = ['..\..\data\' studyName '\' participantID '\'];
filepath = [folderpath pictureName '.txt'];

%read and clean eye tracking data
[eyeTrackingData] = readEyeTrackingData(filepath);
[eyeTrackingData] = cleanEyeTrackingData(eyeTrackingData);

%detect fixation and saccades from raw eye tracking data
[eyeTrackingDistance,eyeTrackingVelocity,eyeTrackingDataLabel,fixation,saccade,fixationPoints,saccadePoints] = returnFixationSaccade(eyeTrackingData);

%read in stimulus image

try
    I = imread(['..\..\stimuli\testing_edited\' pictureName '.png']);
catch
    I = imread(['..\..\stimuli\training\' pictureName '.png']);
end
%reduce contrast so that we can see lighter heat map areas
edgeThreshold = 0;
amount = -0.6;
I_lowcontrast = localcontrast(I,edgeThreshold,amount);

% imshow(I);

% figure;
% % subplot(1,2,1);
% imagesc(I_lowcontrast);
% hold on;
% %%plot fixation points on image
% plot(fixation.x,fixation.y,'wx');

figure('visible','off');
% subplot(1,2,2);
imshow(I_lowcontrast);
hold on;

%create fixation map and dwell map from fixation data
fixationMap = zeros(1050,1680);
[fixationMap] = generateFixationMap(fixationMap,fixation);
dwellMap = zeros(1050,1680);
[dwellMap] = generateDwellMap(dwellMap,fixation);

sigma = 37; %standard deviation of gaussian filter
kernelsize  = 201;
heatMap = imgaussfilt(dwellMap,sigma,'FilterSize',kernelsize); %TOGGLE BETWEEN DWELL OR COUNT (FIXATION)


heatMapMask = (heatMap/max(max(heatMap))) *1;

hm=imagesc(heatMap), colormap('jet');
hm.AlphaData = heatMapMask;

% saveas(gcf,['../../results/heatmap_count_matlab/' studyName '/' participantID '/' pictureName '.png']);
saveas(gcf,['../../results/heatmap_dwell_matlab/' studyName '/' participantID '/' pictureName '.png']);
end
end