
function [mask] = generateMaskFromAOI (aoi)
%compute center of aoi 
cx = round((aoi.x1+aoi.x2)/2);
cy = round((aoi.y1+aoi.y2)/2);

%compute other two coordinates

x3 = aoi.x1;
x4 = aoi.x2;

y3 = aoi.y2;
y4 = aoi.y1;

%convert angle to radians
theta = deg2rad(aoi.angle);

%translate point to origin
tempX1 = aoi.x1 - cx;
tempX2 = aoi.x2 - cx;
tempY1 = aoi.y1 - cy;
tempY2 = aoi.y2 - cy;

tempX3 = x3 - cx;
tempX4 = x4 - cx;
tempY3 = y3 - cy;
tempY4 = y4 - cy;

%now apply rotation
rotatedX1 = tempX1*cos(theta) - tempY1*sin(theta);
rotatedY1 = tempX1*sin(theta) + tempY1*cos(theta);

rotatedX2 = tempX2*cos(theta) - tempY2*sin(theta);
rotatedY2 = tempX2*sin(theta) + tempY2*cos(theta);

rotatedX3 = tempX3*cos(theta) - tempY3*sin(theta);
rotatedY3 = tempX3*sin(theta) + tempY3*cos(theta);

rotatedX4 = tempX4*cos(theta) - tempY4*sin(theta);
rotatedY4 = tempX4*sin(theta) + tempY4*cos(theta);

%translate back
x1 = rotatedX1 + cx;
x2 = rotatedX2 + cx;
y1 = rotatedY1 + cy;
y2 = rotatedY2 + cy;
x3 = rotatedX3 + cx;
x4 = rotatedX4 + cx;
y3 = rotatedY3 + cy;
y4 = rotatedY4 + cy;

x = [x1 x3 x2 x4];
y = [y1 y3 y2 y4];

mask = poly2mask(x,y,1050,1680);
mask = imcomplement(mask); %black out eyes, keep other regions
% imshow(mask);
end