%%Author: Pallavi A Raiturkar
%Name: interpolatePupil
%Parameters: eyeTrackingData
%Returns: pupil
%%This function fills in the missing pupil diameters
%%(eyeTrackingData.pupil=0)
function [output] = interpolatePupil(time)

numberDataPoints = size(time,1);

a = 1:numberDataPoints;
b = 1:numberDataPoints;

zeroTime = time==0; % Zeros locations

time(zeroTime) = [];
a(zeroTime)=[];
output = interp1(a, time, b)';

% figure(3);
% plot(output,'b');
stillZero = find(isnan(output));

if(size(stillZero,1)~=0)
    for i = 1: size(stillZero,1)
        for j = (stillZero(i)+1):size(output,1)
            if(output(j)~=0 && ~isnan(output(j)))
                output(stillZero(i)) = output(j);
                break;
            end
        end
    end
end

stillZero = find(isnan(output));

if(size(stillZero,1)~=0)
    for i = 1: size(stillZero,1)
        for j = (stillZero(i)-1):-1:1
            if(output(j)~=0 && ~isnan(output(j)))
                output(stillZero(i)) = output(j);
                break;
            end
        end
    end
end

% hold on;
% plot(output,'g');

end