%%Author: Pallavi A Raiturkar
%%
%script to generate final heat map for CG and photo (across all
%participants, scaled)
%%
clear all;
clc;
imgName_base= 'cg_f_12';
img_base = imread(['..\..\stimuli\testing\' imgName_base '.png']);
edgeThreshold = 0;
amount = -0.6;
I_lowcontrast = localcontrast(img_base,edgeThreshold,amount);

imgName_other= 'photo_f_12';
img_other = imread(['..\..\stimuli\testing\' imgName_other '.png']);
edgeThreshold = 0;
amount = -0.6;
I_lowcontrast2 = localcontrast(img_other,edgeThreshold,amount);


imgNameList  = returnImageNameList_testing();

%generate CG heat map
fixationMap_cg = zeros(800,609);
dwellMap_cg = zeros(800,609);
for i = 1:30
    pictureName = strtok(char(imgNameList(i)),'.');
    load(['..\..\intermediate\irb\fixation_maps_scaled\' pictureName '_fixation']);
    load(['..\..\intermediate\irb\fixation_maps_scaled\' pictureName '_dwell']);
    fixationMap_cg = fixationMap_cg + fixationMap_scaled;
    dwellMap_cg = dwellMap_cg + dwellMap_scaled;
end

fixationMap_cg = fixationMap_cg./30;
dwellMap_cg = dwellMap_cg./30;

% figure(1);
% x = 1:609;
% y = 1:800;

% imshow(I_lowcontrast);
% for i = 1:800
%     for j = 1:609
%         if(fixationMap_cg(i,j)~=1)
%             plot(i,j,'rx');
%         end
%     end
% end
% set(h,'LineStyle','none')

% mean1 = nonzeros(dwellMap_cg(1:450,:));
% mean1 = mean1./sum(sum(dwellMap_cg));
% mean2 = nonzeros(dwellMap_cg(451:end,:));
% mean2 = mean2./sum(sum(dwellMap_cg));
sigma = 37; %standard deviation of gaussian filter
kernelsize  = 201;
heatMap = imgaussfilt(fixationMap_cg,sigma,'FilterSize',kernelsize); %TOGGLE BETWEEN DWELL OR COUNT (FIXATION)
saliencyMap1 = heatMap;
% h= surf(x,y,heatMap);
% set(h,'LineStyle','none')
heatMapMask = (heatMap/max(max(heatMap))) *0.9;
figure;
imshow((I_lowcontrast));
hold on;
hm=imagesc(heatMap), colormap('jet');
hm.AlphaData = heatMapMask;

fixationMap_photo = zeros(800,609);
dwellMap_photo = zeros(800,609);
%generate photo heat map
for i = 31:60
    pictureName = strtok(char(imgNameList(i)),'.');
    load(['..\..\intermediate\irb\fixation_maps_scaled\' pictureName '_fixation']);
    load(['..\..\intermediate\irb\fixation_maps_scaled\' pictureName '_dwell']);
    fixationMap_photo = fixationMap_photo + fixationMap_scaled;
    dwellMap_photo = dwellMap_photo + dwellMap_scaled;

end
fixationMap_photo = fixationMap_photo./30;
dwellMap_photo = dwellMap_photo./30;

% figure(2);
% x = 1:609;
% y = 1:800;
% % h = surf(x,y,dwellMap_photo);
% % 
% 
% mean3 = nonzeros(dwellMap_photo(1:450,:));
% mean3 = mean3./sum(sum(dwellMap_photo));
% mean4 = nonzeros(dwellMap_photo(451:end,:));
% mean4 = mean4./sum(sum(dwellMap_photo));

sigma = 37; %standard deviation of gaussian filter
kernelsize  = 201;
heatMap = imgaussfilt(fixationMap_photo,sigma,'FilterSize',kernelsize); %TOGGLE BETWEEN DWELL OR COUNT (FIXATION)
% h= surf(x,y,heatMap);
% set(h,'LineStyle','none')
saliencyMap2 = heatMap;
heatMapMask = (heatMap/max(max(heatMap))) *1;
figure;
load('I_affine');
imshow((I_affine));
% imshow(I_lowcontrast2);
hold on;
hm=imagesc(heatMap), colormap('jet');
hm.AlphaData = heatMapMask;



% score = CC(saliencyMap1,saliencyMap2);
[r,p] = corrcoef(saliencyMap1,saliencyMap2)
