%%Script to plot rtime_accuracy etc.
%%
studyName = 'irb2';
numParticipants = 14;
load('correctness');
load('percentDwellTimeBothEyes');
load('type');
load('rtime');
load('pid');
load('rtime_base');
load('pid_base');
A_original = [pid type correctness percentDwellTimeBothEyes rtime];
A_base_original = [pid_base rtime_base];
A = A_original;
A_base = A_base_original;

%remove incorrect responses
A(A(:, 3)== 0, :)= [];

%remove responses greater than 2 standard deviations away, i.e. 7 seconds
%and greater
A(A(:,5)>7000,:) = [];
A_base(A_base(:,2)>2000,:) = [];

%BASELINE
accuracy_base = 100*ones(numParticipants,1);
med_rtime_base = zeros(numParticipants,1);
for i = 1:numParticipants
    med_rtime_base(i,:) = median(A_base(A_base(:,1)==i,2));
end

%plot participant accuracy as a func of reaction time, CG and photo
%different
accuracy_cg = zeros(numParticipants,1);
accuracy_photo = zeros(numParticipants,1);
accuracy = zeros(numParticipants,1);
med_rtime_cg = zeros(numParticipants,1);
med_rtime_photo = zeros(numParticipants,1);
for i = 1:numParticipants
    accuracy_cg(i,:) = (sum(A_original(A_original(:,1)==i&A_original(:,2)==1,3))/30)*100;
    accuracy_photo(i,:) = (sum(A_original(A_original(:,1)==i&A_original(:,2)==0,3))/30)*100;
    accuracy(i,:) = (sum(A_original(A_original(:,1)==i,3))/60)*100;
    B = A(A(:,1)==i,:);
    med_rtime_cg(i,:) = median(B(B(:,2)==1,5));
    med_rtime_photo(i,:) = median(B(B(:,2)==0,5));
end

% figure;
% plot(med_rtime_base*1.0e-3,accuracy_base,'gx');
% hold on;
% plot(med_rtime_cg*1.0e-3,accuracy_cg,'bo');
% hold on;
% plot(med_rtime_photo*1.0e-3,accuracy_photo,'rd');
% 
% 

%divide data into bins
% reactime_cor = A(A(:,2)==1,5);
bin_edges = 0:200:7000;
numBins = size(bin_edges,2)-1;
% Y = discretize(reactime_cor,bin_edges);
% 
% %for each bin and each participant, compute percent correct trials in that
% %bin
% 
percortrials_cg = zeros(numParticipants,numBins);
for i = 1:numParticipants
%     numtrials = size(find(A(A(:,2)==1,5)==i),1); % number of trials for this participant
%     trials = find(pid_cor==i);
    rtime_trials = (A(A(:,2)==1&A(:,1)==i,5));
    numtrials = size(rtime_trials,1)
    rtime_count_trials = discretize(rtime_trials,bin_edges);
    for j = 1:numBins
       percortrials_cg(i,j) = sum(rtime_count_trials==j)/numtrials;
    end
   
end
% 
percortrials_photo = zeros(numParticipants,numBins);
for i = 1:numParticipants
%     numtrials = size(find(A(A(:,2)==1,5)==i),1); % number of trials for this participant
%     trials = find(pid_cor==i);
    rtime_trials = (A(A(:,2)==0&A(:,1)==i,5));
    numtrials = size(rtime_trials,1);
    rtime_count_trials = discretize(rtime_trials,bin_edges);
    for j = 1:numBins
       percortrials_photo(i,j) = sum(rtime_count_trials==j)/numtrials;
    end
   
end
% 
percortrials_base = zeros(numParticipants,numBins);
for i = 1:numParticipants
%     numtrials = size(find(A(A(:,2)==1,5)==i),1); % number of trials for this participant
%     trials = find(pid_cor==i);
    rtime_trials = (A_base(A_base(:,1)==i,2));
    numtrials = size(rtime_trials,1);
    rtime_count_trials = discretize(rtime_trials,bin_edges);
    for j = 1:numBins
       percortrials_base(i,j) = sum(rtime_count_trials==j)/numtrials;
    end
   
end
% 
% % colors = hsv(numParticipants);
% % figure(3);
% % for i = 1:numParticipants
% %     x_base = 0.1:0.2:6.9;
% %    plot(x_base,percortrials(i,:),'Color',colors(i,:,:),'Marker','x');
% %    hold on;
% % 
% % end
figure(4);
hold on;
x_base = 0.1:0.2:6.9;
plot(x_base,mean(percortrials_cg,1)*100,'Marker','o','Color','b');
hold on;
plot(x_base,mean(percortrials_photo,1)*100,'Marker','d','Color','r');
hold on;
plot(x_base,mean(percortrials_base,1)*100,'Marker','x','Color','g');


% boxplot(A_original(:,4),A_original(:,2));
