%%Author: Pallavi A Raiturkar
%%
%script to plot scan path on images
clear all;
clc;

studyName = 'irb';
participantID = 's011';
% pictureName = 'cg_f_1';

imgNameList  = returnImageNameList();

color = 'red';

folderpath = ['..\..\data\' studyName '\' participantID '\'];

for i = 1:80
    pictureName = strtok(char(imgNameList(i)),'.');
filepath = [folderpath pictureName '.txt'];

%read and clean eye tracking data
[eyeTrackingData] = readEyeTrackingData(filepath);
[eyeTrackingData] = cleanEyeTrackingData(eyeTrackingData);

%detect fixation and saccades from raw eye tracking data
[eyeTrackingDistance,eyeTrackingVelocity,eyeTrackingDataLabel,fixation,saccade,fixationPoints,saccadePoints] = returnFixationSaccade(eyeTrackingData);


%read in stimulus image

try
    I = imread(['..\..\stimuli\testing_edited\' pictureName '.png']);
catch
    I = imread(['..\..\stimuli\training\' pictureName '.png']);
end

% %reduce contrast so that we can see lighter heat map areas
% edgeThreshold = 0;
% amount = -0.6;
% I_lowcontrast = localcontrast(I,edgeThreshold,amount);

% imshow(I);

%compute fixation point radii for scan path plot
fixation_duration_normalized = 20*((fixation.duration - min(fixation.duration))./(max(fixation.duration)-min(fixation.duration))) + 20;

% figure;
figure('visible','off');
% subplot(1,2,1);
imshow(I);
hold on;
%%plot fixation points on image
plot(fixation.x,fixation.y,'Marker','none','Color',color);
hold on;
% for i = 1:size(fixation.index)
% rectangle('Position',[(fixation.x(i)-fixation_duration_normalized(i)) (fixation.y(i) -fixation_duration_normalized(i)) (fixation_duration_normalized(i)*2) (fixation_duration_normalized(i)*2)],'Curvature',[1 1],'FaceColor',[0.58 0 0.82],'FaceAlpha',0.5);
plotCircle(fixation.x,fixation.y,fixation_duration_normalized,'EdgeColor','white','FaceColor',color,'FaceAlpha',0.4);
% hold on;
% end
hold on;
text(fixation.x,fixation.y,[num2str(fixation.index)],'HorizontalAlignment','center');
% hold on;
% text(fixation.x,fixation.y+20,[num2str(round(fixation.duration*1.0e-6,2))],'HorizontalAlignment','right');
% hold on;
% plot(saccadePoints.x,saccadePoints.y,'Marker','x','MarkerSize',10,'Color','r');

saveas(gcf,['../../results/scanpath_plots/' studyName '/' participantID '/' pictureName '.png']);
end