%%Script to plot percent correct trials against reaction time windows:
numParticipants = 9;
%%remove samples > 1%

reactime_cor = rtime_vec_cor(rtime_vec_cor<4900);
pid_cor = pid_vec_cor(rtime_vec_cor<4900);

% hist(reactime_cor)

%divide data into bins
bin_edges = 200:200:5000;
numBins = size(bin_edges,2)-1;
Y = discretize(reactime_cor,bin_edges);

%for each bin and each participant, compute percent correct trials in that
%bin

percortrials = zeros(numParticipants,numBins);
for i = 1:numParticipants
    numtrials = size(find(pid_cor==i),1); % number of trials for this participant
    trials = find(pid_cor==i);
    rtime_trials = reactime_cor(trials);
    rtime_count_trials = discretize(rtime_trials,bin_edges);
    for j = 1:numBins
       percortrials(i,j) = sum(rtime_count_trials==j)/numtrials;
    end
   
end

colors = hsv(9);
figure(3);
for i = 1:9
    x_base = 0.3:0.2:4.9;
   plot(x_base,percortrials(i,:),'Color',colors(i,:,:),'Marker','x');
   hold on;

end

figure(4);
x_base = 0.3:0.2:4.9;
plot(x_base,mean(percortrials,1),'Marker','x');
