%%Script to plot percent correct trials against reaction time windows:
numParticipants = 9;
%%remove samples > 1%

reactimebase_cor = rtime_baseline_vec(rtime_baseline_vec<1390);
pid_base = ones(10,1)*(1:9);
pid_base = reshape(pid_base,[90,1]);
pid_cor = pid_base(rtime_baseline_vec<1390);

% hist(reactime_cor)

%divide data into bins
bin_edges = 0:200:5000;
numBins = size(bin_edges,2)-1;
Y = discretize(reactimebase_cor,bin_edges);

%for each bin and each participant, compute percent correct trials in that
%bin

percortrials = zeros(numParticipants,numBins);
for i = 1:numParticipants
    numtrials = size(find(pid_cor==i),1); % number of trials for this participant
    trials = find(pid_cor==i);
    rtime_trials = reactimebase_cor(trials);
    rtime_count_trials = discretize(rtime_trials,bin_edges);
    for j = 1:numBins
       percortrials(i,j) = sum(rtime_count_trials==j)/numtrials;
    end
   
end

colors = hsv(9);
figure(6);
for i = 1:9
    x_base = 0.1:0.2:4.9;
   plot(x_base,percortrials(i,:),'Color',colors(i,:,:),'Marker','x');
   hold on;

end

figure(4);
hold on;
x_base = 0.1:0.2:4.9;
plot(x_base,mean(percortrials,1),'Marker','o');
