%%Author: Pallavi A Raiturkar
%%script to scale all fixation maps to one size (cg_f_12 as basis)
clear all;
clc;

participantID_list = returnParticipantList();
participantID_list(35,:) = [];
participantID_list(16,:) = [];

numParticipants = size(participantID_list,1);

%load base image points
imgName_base= 'cg_f_12';
img_base = imread(['..\..\stimuli\testing\' imgName_base '.png']);
xbar = load(['..\..\intermediate\irb\eyes_mouth_points\' imgName_base '_x']);
xbar = xbar.x;
ybar = load(['..\..\intermediate\irb\eyes_mouth_points\' imgName_base '_y']);
ybar = ybar.y;

b = [xbar(1);
    ybar(1);
    xbar(2);
    ybar(2);
    xbar(3);
    ybar(3);
    xbar(4);
    ybar(4)];

[imgNameList]  = returnImageNameList_testing();

for i = 1:60
% i = 1;
    pictureName = strtok(char(imgNameList(i)),'.');
    x = load(['..\..\intermediate\irb\eyes_mouth_points\' pictureName '_x']);
    x = x.x;
    y = load(['..\..\intermediate\irb\eyes_mouth_points\' pictureName '_y']);
    y = y.y;
    
    for j = 1:numParticipants
        participantID = participantID_list(j,:);
    load(['..\..\intermediate\irb\fixation_maps_noeyes_byparticipant\' pictureName '_' participantID '_fixation']);
    load(['..\..\intermediate\irb\fixation_maps_noeyes_byparticipant\' pictureName '_' participantID '_dwell']);
    M = [x(1) y(1) 0 0 1 0; 
    0 0 x(1) y(1) 0 1; 
    x(2) y(2) 0 0 1 0; 
    0 0 x(2) y(2) 0 1;
    x(3) y(3) 0 0 1 0;
    0 0 x(3) y(3) 0 1;
    x(4) y(4) 0 0 1 0;
    0 0 x(4) y(4) 0 1];

    u = M\b;
    
    T  = [u(1) u(3)  0;
          u(2) u(4)  0;
          u(5) u(6) 1];

    t_aff = affine2d(T);
    fixationMap_scaled = imwarp(fixationMap,t_aff,'OutputView',imref2d(size(img_base)));
    dwellMap_scaled = imwarp(dwellMap,t_aff,'OutputView',imref2d(size(img_base)));
    save(['..\..\intermediate\irb\fixation_maps_noeyes_scaled_byparticipant\' pictureName '_' participantID '_fixation'],'fixationMap_scaled');
    save(['..\..\intermediate\irb\fixation_maps_noeyes_scaled_byparticipant\' pictureName '_' participantID '_dwell'],'dwellMap_scaled');
    end
end