%%Author: Pallavi A Raiturkar
%%
%script to generate final heat map for CG and photo (across all
%participants, scaled)
%%
clear all;
clc;
studyName = 'irb';
imgName_base= 'cg_f_12';
img_base = imread(['..\..\stimuli\testing\' imgName_base '.png']);
edgeThreshold = 0;
amount = -0.6;
I_lowcontrast = localcontrast(img_base,edgeThreshold,amount);

imgNameList  = returnImageNameList_testing();
participantID_list = returnParticipantList();
participantID_list(35,:) = [];
participantID_list(16,:) = [];

numParticipants = size(participantID_list,1);
%generate CG heat map


filename_read = ['..\..\intermediate\' studyName '\eyetrackingcg_data.xlsx']; %Replace with filepath containing data table
[~,~,data]=xlsread(filename_read);

correctness = data(2:end,9);

correctness = reshape(correctness,[60 35]);

correctness(:,35) = [];
correctness(:,16) = [];

correctness = strcmp(correctness,'correct');
fixationMap_cg_cor = zeros(800,609);
dwellMap_cg_cor = zeros(800,609);
count = 0;
for i = 1:30
    for j = 1:33
        if(correctness(i,j)==1)
        pictureName = strtok(char(imgNameList(i)),'.');
        participantID = participantID_list(j,:);
        load(['..\..\intermediate\irb\fixation_maps_scaled_byparticipant\' pictureName '_' participantID '_fixation']);
        load(['..\..\intermediate\irb\fixation_maps_scaled_byparticipant\' pictureName '_' participantID '_dwell']);
        fixationMap_cg_cor = fixationMap_cg_cor + fixationMap_scaled;
        dwellMap_cg_cor = dwellMap_cg_cor + dwellMap_scaled;
        count = count + 1;
        end
    end
end
count
fixationMap_cg_cor = fixationMap_cg_cor./count;
dwellMap_cg_cor = dwellMap_cg_cor./count;

sigma = 37; %standard deviation of gaussian filter
kernelsize  = 201;
heatMap = imgaussfilt(dwellMap_cg_cor,sigma,'FilterSize',kernelsize); %TOGGLE BETWEEN DWELL OR COUNT (FIXATION)


% heatMapMask = (heatMap/max(max(heatMap))) *1;
subplot(2,2,1);
hm=imagesc(heatMap), colormap('jet');
% hm.AlphaData = heatMapMask;

fixationMap_cg_incor = zeros(800,609);
dwellMap_cg_incor = zeros(800,609);


count = 0;
%generate incorrect CG heat map
for i = 1:30
    for j = 1:33
        if(correctness(i,j)==0)
        pictureName = strtok(char(imgNameList(i)),'.');
        participantID = participantID_list(j,:);
        load(['..\..\intermediate\irb\fixation_maps_scaled_byparticipant\' pictureName '_' participantID '_fixation']);
        load(['..\..\intermediate\irb\fixation_maps_scaled_byparticipant\' pictureName '_' participantID '_dwell']);
        fixationMap_cg_incor = fixationMap_cg_incor + fixationMap_scaled;
        dwellMap_cg_incor = dwellMap_cg_incor + dwellMap_scaled;
        count = count + 1;
        end
    end
end
count
fixationMap_cg_incor = fixationMap_cg_incor./count;
dwellMap_cg_incor = dwellMap_cg_incor./count;



sigma = 37; %standard deviation of gaussian filter
kernelsize  = 201;
heatMap = imgaussfilt(dwellMap_cg_incor,sigma,'FilterSize',kernelsize); %TOGGLE BETWEEN DWELL OR COUNT (FIXATION)


% heatMapMask = (heatMap/max(max(heatMap))) *1;
subplot(2,2,2);
% load('I_affine');
% imshow((I_lowcontrast));
% hold on;
hm=imagesc(heatMap), colormap('jet');
% hm.AlphaData = heatMapMask;



%%%FOR PHOTOGRAPHS

fixationMap_photo_cor = zeros(800,609);
dwellMap_photo_cor = zeros(800,609);
count = 0;
for i = 31:60
    for j = 1:33
        if(correctness(i,j)==1)
        pictureName = strtok(char(imgNameList(i)),'.');
        participantID = participantID_list(j,:);
        load(['..\..\intermediate\irb\fixation_maps_scaled_byparticipant\' pictureName '_' participantID '_fixation']);
        load(['..\..\intermediate\irb\fixation_maps_scaled_byparticipant\' pictureName '_' participantID '_dwell']);
        fixationMap_photo_cor = fixationMap_photo_cor + fixationMap_scaled;
        dwellMap_photo_cor = dwellMap_photo_cor + dwellMap_scaled;
        count = count + 1;
        end
    end
end
count
fixationMap_photo_cor = fixationMap_photo_cor./count;
dwellMap_photo_cor = dwellMap_photo_cor./count;

sigma = 37; %standard deviation of gaussian filter
kernelsize  = 201;
heatMap = imgaussfilt(dwellMap_photo_cor,sigma,'FilterSize',kernelsize); %TOGGLE BETWEEN DWELL OR COUNT (FIXATION)


% heatMapMask = (heatMap/max(max(heatMap))) *1;
subplot(2,2,3);
hm=imagesc(heatMap), colormap('jet');
% hm.AlphaData = heatMapMask;

fixationMap_photo_incor = zeros(800,609);
dwellMap_photo_incor = zeros(800,609);


count = 0;
%generate incorrect photo heat map
for i = 31:60
    for j = 1:33
        if(correctness(i,j)==0)
        pictureName = strtok(char(imgNameList(i)),'.');
        participantID = participantID_list(j,:);
        load(['..\..\intermediate\irb\fixation_maps_scaled_byparticipant\' pictureName '_' participantID '_fixation']);
        load(['..\..\intermediate\irb\fixation_maps_scaled_byparticipant\' pictureName '_' participantID '_dwell']);
        fixationMap_photo_incor = fixationMap_photo_incor + fixationMap_scaled;
        dwellMap_photo_incor = dwellMap_photo_incor + dwellMap_scaled;
        count = count + 1;
        end
    end
end
count
fixationMap_photo_incor = fixationMap_photo_incor./count;
dwellMap_photo_incor = dwellMap_photo_incor./count;



sigma = 37; %standard deviation of gaussian filter
kernelsize  = 201;
heatMap = imgaussfilt(dwellMap_photo_incor,sigma,'FilterSize',kernelsize); %TOGGLE BETWEEN DWELL OR COUNT (FIXATION)


% heatMapMask = (heatMap/max(max(heatMap))) *1;
subplot(2,2,4);
hm=imagesc(heatMap), colormap('jet');
% hm.AlphaData = heatMapMask;
